[OpenWrt-Devel] [PATCH 2/4] ath79: add QCA955x SGMII link loss workaround

Chuanhong Guo gch981213 at gmail.com
Fri May 31 19:15:49 PDT 2019


On Sat, Jun 1, 2019 at 12:26 AM Christian Lamparter <chunkeey at gmail.com> wrote:
>
> On Friday, May 31, 2019 4:44:50 PM CEST Chuanhong Guo wrote:
> > Hi!
> >
> > On Fri, May 31, 2019 at 9:34 PM Christian Lamparter <chunkeey at gmail.com> wrote:
> > >
> > > Not to be a party pooper. The ag71xx is well on its way to upstream.
> > > https://git.kernel.org/pub/scm/linux/kernel/git/davem/net-next.git/commit/drivers/net/ethernet/atheros/ag71xx.c?id=d51b6ce441d356369387d20bc1de5f2edb0ab71e
> > >
> > > So sadly this all would need to be somehow upstreamed first and then
> > > backported again. *sight* :(
> > >
> > The upstream driver is pretty much broken on every SoCs with external
> > PHY/switch. Getting every ath79 SoC working with that driver is
> > already a headache.
> >
> > I think we should just keep maintaining our ag71xx driver until
> > someone having a pile of ath79 routers get that driver working.
>
> Well, look what happend to ar71xx then. The development on it is being
> defered in favor of the upstream ath79 dts. So what do you think will
> happen to the special out-of-tree ag71xx drivers now?

That happens after we got ath79 target working. There is a period of
time when ath79 has broken wireless support, during which ar71xx
patches were still accepted.

Author of upstream ag71xx driver did a 'rework' of OpenWrt ag71xx
driver dropped all mii interface configuration stuff. Unless someone
patches it back, it won't work on qca9558 in this case.
To upstream this particular patch, we need to:
1. patch mii interface configuration code back. (Somehow we named it
PLL and the author thought it's a clock register that doesn't belong
to ethernet driver.)
2. patch the miscellaneous ethernet-related configuration code back.
(gmac-config in our driver which is used by this patch.)
Our current code for both of them will have little chance being
accepted by upstream.

Since this patch depends on gmac-config that doesn't exist in upstream
ag71xx yet and we won't be using the upstream driver in upcoming 19.x
release, I think it's fine to have this problem fixed in our driver
and then port it upstream (likely to be a rework) with gmac-config
code.



More information about the openwrt-devel mailing list